start = Sys.time()

setwd("C:\\VertrigoServ\\www")

# phpSerialize Web example
library(phpSerialize)

# Carrega o pacote "psych"
library(psych)
library(graphics)
library(GPArotation)

# htest object
NumQuest = as.numeric(Sys.getenv("NumQuest")) # How to get information from php
NumItem = as.numeric(Sys.getenv("NumItem")) # How to get information from php


Sys.setenv(MYSQL_HOME="C:\\VertrigoServ\\Mysql")

library(RMySQL)

# Conecta e seleciona o BD chamado "sistema_servqual"
con = dbConnect(dbDriver("MySQL"), dbname = "sistema_servqual",
user="root",password="vertrigo", host="localhost")

##########################################
# L a tabela "questoes_adicionais" e 
# atribui ao objeto "quest_adicionais"
###########################################
quest_adicionais = dbReadTable(con, "questoes_adicionais")

##########################################
# L a tabela "questoes_servqual" e 
# atribui ao objeto "quest_servqual"
###########################################
quest_servqual = dbReadTable(con, "questoes_servqual")

##########################################
# L a tabela "respostas_adicinais" e 
# atribui ao objeto "resp_adicionais"
###########################################
resp_adicionais = dbReadTable(con, "respostas_adicionais")


##########################################
# L a tabela "respostas_servqual" e 
# atribui ao objeto "resp_servqual"
###########################################
resp_servqual = dbReadTable(con, "respostas_servqual")

numero_questao <-  NumQuest
num_item <- NumItem

#temp01 <- subset(resp_adicionais,(num_quest == numero_questao) & (resposta == num_item) , select = login)
temp01 <- subset(resp_adicionais, select = login)
temp01 <- as.numeric(temp01[[1]])

temp02 <- NULL # objeto contendo apenas as questes servqual respondidas pelo subgrupo desejado
#for(i in 1:length(temp01)){
#x = subset(resp_servqual, resp_servqual$login == temp01[i] , select = c(questao,n_minimo,n_maximo,n_percebido))
#x <- as.matrix(x)
#temp02 <- rbind(temp02,x)
#}

temp02 <- subset(resp_servqual,select = c(questao,n_minimo,n_maximo,n_percebido))
temp02 <- as.data.frame(temp02)

temp03 <- NULL # objeto contendo apenas as questes adicionais respondidas pelo subgrupo desejado
#for(i in 1:length(temp01)){
#x = subset(resp_adicionais,login == temp01[i], c(num_quest,resposta))
#x <- as.matrix(x)
#temp03 <- rbind(temp03,x)
#}
temp03 <- subset(resp_adicionais, select=c(num_quest,resposta))
temp03 <- as.data.frame(temp03)

num_quest_adic <- max(temp03$num_quest)

resp_adicionais <- matrix(temp03$resposta,ncol=num_quest_adic,byrow=T)
colnames(resp_adicionais) <- paste("Qst_",1:num_quest_adic,sep="")

### Anlise descritiva questes adicionais
analis_descrit_quest_adic <- list()

for(i in 1:num_quest_adic){

parte01 <- as.matrix(data.frame(table(resp_adicionais[,i])))
parte02 <- as.matrix(data.frame(subset(quest_adicionais,num_quest==i,num_item),0))

rownames(parte01) <- NULL
rownames(parte02) <- NULL

resp_adicionais2 <- (rbind(parte01,parte02))
resp_adicionais2 <- matrix(as.numeric(resp_adicionais2),ncol=2,byrow=F)
resp_adicionais2 <- as.data.frame(resp_adicionais2)
colnames(resp_adicionais2) <- c("item","freq")

prop_quest <- prop.table(tapply(resp_adicionais2$freq,resp_adicionais2$item, sum))
names(prop_quest) <- subset(quest_adicionais,num_quest==i,label_item)[[1]]

analis_descrit_quest_adic[[i]] <- prop_quest

jpeg(paste("graf_adic_",numero_questao,"_",num_item,"_",i,".jpeg",sep=""),w=800,h=400,quality=95)
pie(round(prop_quest*100,2),col=rainbow(length(round(prop_quest*100,2))),border=NA, paste(round(prop_quest*100,2),"%"),cex=1.2,radius=.9)
cores = rainbow(length(round(prop_quest*100,2)))
legend("right",box.lty=0,fill=cores,title="",names(prop_quest),cex=1.1,border=NA)
dev.off()

}

#####
# Gera o objeto para criar as tabelas das questes adicionais
#####
prop_tabelas <- NULL
for(i in 1:num_quest_adic){
prop_tabelas <- c(prop_tabelas,analis_descrit_quest_adic[[i]])
}

temp04 <- data.frame(quest_adicionais, prop_tabelas)
#names(temp04) <- c(names(quest_adicionais),"prop_tabelas")

questoes <- paste(quest_servqual$questao,"-",quest_servqual$label_questao,sep="")
NmA <- tapply(temp02$n_minimo,temp02$questao,mean,na.rm=T)
NmD <- tapply(temp02$n_maximo,temp02$questao,mean,na.rm=T)
NP <- tapply(temp02$n_percebido,temp02$questao,mean,na.rm=T)

tabela_medias <- cbind(questoes, round(NmA,3),round(NmD,3), round(NP,3), quest_servqual$dimensao)
tabela_medias <- as.data.frame(tabela_medias)
names(tabela_medias) <- c("questao","nma","nmd","np","dimensao")

qtd_quest_servqual <- dim(tabela_medias)[1]

dbWriteTable(con,"prop_quest_adicionais",temp04,overwrite = T)



# ---------------------------------------------------------------------
## Grfico Radar - Inicio
#
jpeg(paste("graf_radar_",numero_questao,"_",num_item,".jpeg",sep=""),w=600,h=600,quality=100)

r=9;theta=0
rpretty <- pretty(range(abs(r), 0, na.rm=TRUE))
rmax <- rpretty[length(rpretty)]
plot.new()
plot.window(xlim = c(-rmax, rmax),ylim = c(-rmax, rmax),asp = 1)
grid <- seq(0, 2 * pi, length = 360 / 5 + 1)
for(rad in rpretty){
if(rad > 0)
lines(rad * cos(grid), rad * sin(grid), col = "gray")
}
rad <- seq(0, 2 * pi, length = qtd_quest_servqual + 1)[-1]
segments(0, 0, rmax * cos(rad), rmax * sin(rad), col = "gray")


# Divide uma circunfer. em 40 partes ( em radianos)
angulo <- seq(0,2*pi,l=(qtd_quest_servqual+1)) 

# Objeto que contm os dados a serem plotados (as mdias do NmA, NmD, NP)
aaa <- tabela_medias[,2:4]

nomes <- rownames(aaa)
aaa <- matrix(as.numeric(matrix(as.matrix(aaa),ncol=1)),ncol=3,byrow=F)
rownames(aaa) <- nomes

xx <- matrix(rep(0,qtd_quest_servqual*3),ncol=3)
yy <- xx
p.x <- numeric(qtd_quest_servqual)
p.y <- numeric(qtd_quest_servqual)

for(j in 1:3){ 
  for(i in 1:qtd_quest_servqual){
    yy[i,j] <- aaa[i,j]*sin(angulo[i])
    xx[i,j] <- aaa[i,j]*cos(angulo[i])

    p.x[i] <- 10.1*cos(angulo[i])
    p.y[i] <- 10.1*sin(angulo[i])
  }
}

#Plotando as trs linhas
lines(c(xx[,1],xx[1,1]),c(yy[,1],yy[1,1]),col ="red")
points(xx[,1],yy[,1],col = "red", pch = 20,cex=1.5)

lines(c(xx[,2],xx[1,2]),c(yy[,2],yy[1,2]),col ="blue")
points(xx[,2],yy[,2],col = "blue", pch = 20,cex=1.5)

lines(c(xx[,3],xx[1,3]),c(yy[,3],yy[1,3]),col ="green")
points(xx[,3],yy[,3],col = "green", pch = 20,cex=1.5)

text(p.x,p.y,rownames(aaa),cex=1)

title("Mdias Obtidas pelos Itens nos Nveis Avaliados")

nomes = c("NmA","NMD","NP")
legend("bottomright",legend = nomes, col=c("red","blue","green"), pch=c(20,20,20),lty=1, trace=FALSE, cex=1,bty="n")

dev.off()

# ---------------------------------------------------------------------
## Grfico Radar - Fim
# ---------------------------------------------------------------------

tabela_medias <- data.frame(tabela_medias,ifelse(aaa[,3] >= aaa[,1],1,0))

# Se na "tabela_medias" a coluna estiver acima no "NmA" 
#(nvel mnimo aceitvel), a coluna "acima_nma" valer 1


niv_dim <- levels(tabela_medias$dimensao)


dimensoes <- data.frame(levels(tabela_medias$dimensao),1:length(niv_dim))
names(dimensoes) <- c("dimensao","num_dimensao")

temp05 <- NULL

for(ii in 1:qtd_quest_servqual){
temp05 <- c(temp05,subset(dimensoes,
dimensao == tabela_medias$dimensao[[ii]],
num_dimensao)[[1]])
}

tabela_medias <- data.frame(tabela_medias,temp05)

names(tabela_medias) <- c("questao","nma","nmd","np","dimensao","acima_nma","numero_dimensao")


dbWriteTable(con,"medias_servqual",tabela_medias,overwrite = T)


rownames(tabela_medias) <- paste("Q",rownames(tabela_medias),sep="")

m <- subset(tabela_medias,1==1,c(nma,nmd,np))
nomes_linhas <- row.names(m)
m <- matrix(as.numeric(matrix(as.matrix(m))),byrow=F,ncol=3)
m <- as.data.frame(m)
row.names(m) <- nomes_linhas
names(m) <- c("nma","nmd","np")

m1 <- subset(tabela_medias,acima_nma==1,c(nma,nmd,np)) # Avaliados acima do NmA
nomes_linhas <- row.names(m1)
m1 <- matrix(as.numeric(matrix(as.matrix(m1))),byrow=F,ncol=3)
m1 <- as.data.frame(m1)
row.names(m1) <- nomes_linhas
names(m1) <- c("nma","nmd","np")

m2 <- subset(tabela_medias,acima_nma==0,c(nma,nmd,np)) # Avaliados abaixo do NmA
nomes_linhas <- row.names(m2)
m2 <- matrix(as.numeric(matrix(as.matrix(m2))),byrow=F,ncol=3)
m2 <- as.data.frame(m2)
row.names(m2) <- nomes_linhas
names(m2) <- c("nma","nmd","np")


numero_questao <-  NumQuest
num_item <- NumItem


#####
## 6 - tens Avaliados Acima do NmA 
#####

if(dim(m1)[1] != 0){
jpeg(paste("graf_itens_aval_acima_",numero_questao,"_",num_item,".jpeg",sep=""),w=700,h=500,quality=100)
barplot(t(m1[,1:3]),bg="gray",main="tens Avaliados acima do NmA",axis.lty=0,beside=T,col=c("darkgreen","blue","yellow"),cex.axis=.8,ylim=c(0,10),cex=.8,las=2,tck=1,border=NA)
nomes = c("NmA","NMD","NP")
legend("topright",box.lty=1,fill=c("darkgreen","blue","yellow"),nomes,cex=.8)
dev.off()
}



#####
## 7 - tens Avaliados Abaixo do NmA 
#####

if(dim(m2)[1] != 0){
jpeg(paste("graf_itens_aval_abaixo_",numero_questao,"_",num_item,".jpeg",sep=""),w=700,h=500,quality=100)
barplot(t(m2[,1:3]),main="tens Avaliados abaixo do NmA",axis.lty=0,beside=T,col=c("darkgreen","blue","yellow"),cex.axis=.8,ylim=c(0,10),cex=.8,las=2,tck=1,border=NA)
nomes = c("NmA","NMD","NP")
legend("topright",box.lty=1,fill=c("darkgreen","blue","yellow"),nomes,cex=.8)
dev.off()
}



#####
## 8 - Mdia geral 
#####

jpeg(paste("graf_media_geral_",numero_questao,"_",num_item,".jpeg",sep=""),w=700,h=500,quality=100)
media = c(mean(m[,1]),mean(m[,2]),mean(m[,3]),0)
names(media) = c("NmA","NmD","NP","")
barplot(media,hor=T,border=F,las=1,xlim=c(0,10),main="Mdia Geral dos tens Avaliados",col=c("darkgreen","blue","yellow"),cex.axis=1.3,cex.main=1.5)
legend("topright",box.lty=0,border=NA,fill=c("yellow","blue","darkgreen"),c("NP","NmD","NmA"),cex=1)
text(media[-4]+1.2,c(.8,1.9,3.1),round(media[-4],3),1,cex=1.3)
dev.off()
#######



#################################################
##### ANLISE DE CONFIABILIDADE E VALIDADE   ####
#####        DA ESCALA (QUESTIONRIO)        ####
#################################################

qtd_dimensoes <- max(dimensoes$num_dimensao)

# tabela com nmero da questo e respectivo nmero da questo
dime_quest0 <- cbind(1:dim(tabela_medias)[1],tabela_medias$numero_dimensao)

# nmero de questes atualmente pertencentes a dimenso 1
dime_quest <- function(dimensao){
subset(dime_quest0[,1],dime_quest0[,2]==dimensao)
}



dados.mss <- cbind(temp02$questao,temp02$n_percebido - temp02$n_minimo)
dados.mss <- matrix(dados.mss[,2],ncol=max(dados.mss[,1]),byrow=T)
#dados.mss <-dados.mss[1:20,]#excluir esta linhas (apenas um teste feito em 2-2-2011)
#dados.mss <- as.matrix(na.omit(dados.mss))

#-----------------------------------------------------------------------
#----------------  INICIO ----------------------------------------------
#-----------------------------------------------------------------------
##    CDIGO QUE CONSIDERA APENAS AS LINHAS QUE CONTM PELO MENOS 
##    75% DE SEUS ELEMENTOS COMPLETOS, OU SEJA, NO MISSING
#-----------------------------------------------------------------------

qtd_lin <- dim(dados.mss)[1]
qtd_col <- dim(dados.mss)[2]

qtd_NA <- apply(as.matrix(1:qtd_lin),1,function(x){summary(rbind(t(dados.mss),NA)[,x])[[7]]}) - 1


dados.mss.x <- dados.mss[subset(1:qtd_lin,qtd_NA<=.25*qtd_col),]


kaioken <- NULL
for(k in 1:qtd_col)
{
	kaioken <- cbind(kaioken,
	apply(matrix(dados.mss.x[,k]),2,
	function(x){
	ifelse(is.na(x)==T, mean(dados.mss.x[,k],na.rm=T),x)
		     }
			  )
)
}

dados.mss <- kaioken

#-----------------------------------------------------------------------
#----------------  FIM ----------------------------------------------
#-----------------------------------------------------------------------
##    CDIGO QUE CONSIDERA APENAS AS LINHAS QUE CONTM PELO MENOS 
##    75% DE SEUS ELEMENTOS COMPLETOS, OU SEJA, NO MISSING
#-----------------------------------------------------------------------



dados.msa <- cbind(temp02$questao,temp02$n_percebido - temp02$n_maximo)
dados.msa <- matrix(dados.msa[,2],ncol=max(dados.msa[,1]),byrow=T)
#dados.msa <-dados.msa[1:20,]#excluir esta linhas (apenas um teste feito em 2-2-2011)
#dados.msa <- as.matrix(na.omit(dados.msa))

#-----------------------------------------------------------------------
#----------------  INICIO ----------------------------------------------
#-----------------------------------------------------------------------
##    CDIGO QUE CONSIDERA APENAS AS LINHAS QUE CONTM PELO MENOS 
##    75% DE SEUS ELEMENTOS COMPLETOS, OU SEJA, NO MISSING
#-----------------------------------------------------------------------

qtd_lin <- dim(dados.msa)[1]
qtd_col <- dim(dados.msa)[2]

qtd_NA <- apply(as.matrix(1:qtd_lin),1,function(x){summary(rbind(t(dados.msa),NA)[,x])[[7]]}) - 1



dados.msa.x <- dados.msa[subset(1:qtd_lin,qtd_NA<=.25*qtd_col),]


kaioken<- NULL
for(k in 1:qtd_col)
{
	kaioken <- cbind(kaioken,
	apply(matrix(dados.msa.x[,k]),2,
	function(x){
	ifelse(is.na(x)==T, mean(dados.msa.x[,k],na.rm=T),x)
		     }
			  )
)
}

dados.msa <- kaioken

#-----------------------------------------------------------------------
#----------------  FIM ----------------------------------------------
#-----------------------------------------------------------------------
##    CDIGO QUE CONSIDERA APENAS AS LINHAS QUE CONTM PELO MENOS 
##    75% DE SEUS ELEMENTOS COMPLETOS, OU SEJA, NO MISSING
#-----------------------------------------------------------------------




# ...... XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

teste.zona.tol <- cbind(temp02$questao,temp02$n_minimo,temp02$n_maximo,temp02$n_maximo - temp02$n_minimo, temp02$n_percebido)
colnames(teste.zona.tol) <- c("quest","min","max","zona_tol","perceb")

tamanho <- dim(teste.zona.tol)[1]

temp <- NULL

for(i in 1:tamanho){
	if(is.na(teste.zona.tol[i,2])==T){temp[i] <- NA}
	if(is.na(teste.zona.tol[i,2])==F)
	{
		if(teste.zona.tol[i,5] < teste.zona.tol[i,2]){temp[i] <- 1}
		if((teste.zona.tol[i,5] >= teste.zona.tol[i,2]) & (teste.zona.tol[i,5] < teste.zona.tol[i,2] + 0.5*teste.zona.tol[i,2])){temp[i] <- 2}
		if((teste.zona.tol[i,5] >= teste.zona.tol[i,2] + 0.5*teste.zona.tol[i,2])){temp[i] <- 3}
	}
}

num_var <- dim(dados.mss)[2]

a <- matrix(temp,ncol=num_var,byrow=T)


temp_2 <- NULL
for(j in 1:num_var){

xx <- factor(a[,j],levels=1:3)

g <- as.numeric(table(xx))
g <- t(as.matrix(g))
temp_2 <- rbind(temp_2,g)
}

tabela_medias2 <- cbind(data.frame(tabela_medias[,1]), rowSums(temp_2),round(prop.table(temp_2,1)*100,1))
colnames(tabela_medias2) <- c("questao","respondentes","abaixo_min","acima_min","acima_min2")

# Cria uma nova tabela (com itens na NOVA CATEGORIA)!!!
dbWriteTable(con,"medias_servqual2",tabela_medias2,overwrite = T)


# ...... XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


## Grava as dimenses(tamanho, ou seja, o nmero de linhas e de colunas) do banco de dados imputados (pois um banco de dados,
## muito reduzido, impossibilita a realizao da anlise fatorial)

tamanho_bd <- data.frame(c('qtd_linhas','qtd_colunas'),dim(dados.mss),ifelse(dim(dados.mss)[1]>dim(dados.mss)[2],11,22))
names(tamanho_bd) <- c('local','qtd','mais_linha_que_coluna')

dbWriteTable(con,"tamanho_bd",tamanho_bd,overwrite = T)

if(tamanho_bd$mais[[1]]==11){

################################
#### Normalidade Multivariada
################################

media.mss <- colMeans(dados.mss)
media.msa <- colMeans(dados.msa)

dados.mss <- as.matrix(dados.mss)
dados.msa <- as.matrix(dados.msa)

variancia.mss <- var(dados.mss)
variancia.msa <- var(dados.msa)

qtd_itens <- dim(dados.mss)[2]

jpeg(paste("normalidade_multivariada.jpeg",sep=""),w=800,h=400,quality=100)

par(mfrow=c(1,2))

dist.mss <- NULL
n.mss <- dim(dados.mss)[1]
for(i in 1:n.mss){
dist.mss[i] <- t(dados.mss[i,]-media.mss)%*%solve(variancia.mss)%*%(dados.mss[i,]-media.mss)
}



q.obs.mss <- sort(dist.mss)
q.teor.mss <- qchisq((1:n.mss - .5)/n.mss,dim(dados.mss)[2])

#ks.test(q.obs.mss,"pchisq",qtd_itens)$p.value -> valor.p.ks.mss
#teste.norm.mss <- paste("Teste K-S \n(valor-p: ",format(round(valor.p.ks.mss,7),decimal.mark=","),")",sep="")


plot(q.obs.mss, q.teor.mss,pch=20,col="blue",
cex=1.2,ylab=expression(chi^2 - Terico),
xlab= expression(d[j]^2 - Ordenadas)
,las=1,
main="Grfico Q-Q Plot - Matriz MSS")
#text(20,45,teste.norm.mss,cex=1.3)
abline(lm(q.teor.mss ~ q.obs.mss))


dist.msa <- NULL
n.msa <- dim(dados.msa)[1]
for(i in 1:n.msa){
dist.msa[i] <- t(dados.msa[i,]-media.msa)%*%solve(variancia.msa)%*%(dados.msa[i,]-media.msa)
}

q.obs.msa <- sort(dist.msa)
q.teor.msa <- qchisq((1:n.msa - .5)/n.msa,dim(dados.msa)[2])

#ks.test(q.obs.msa,"pchisq",qtd_itens)$p.value -> valor.p.ks.msa
#teste.norm.msa <- paste("Teste K-S \n(valor-p: ",format(round(valor.p.ks.msa,7),decimal.mark=","),")",sep="")

plot(q.obs.msa, q.teor.msa,pch=20,col="blue",
cex=1.2,ylab=expression(chi^2 - Terico),
xlab= expression(d[j]^2 - Ordenadas)
,las=1,
main="Grfico Q-Q Plot - Matriz MSA")
#text(20,45,teste.norm.msa,cex=1.3)
abline(lm(q.teor.msa ~ q.obs.msa))

dev.off()

############################################
#### TESTE DE ESFERICIDADE DE BARTLETT #####
############################################

correl.mss <- cor(dados.mss)
correl.msa <- cor(dados.msa)

bartlett_mss <- paste("Estatstica do Teste: ",
round(cortest.bartlett(correl.mss, n = n.mss)$chisq,2),
" (valor-p = ",
round(cortest.bartlett(correl.mss, n = n.mss)$p.value,4),
")",sep="")

bartlett_msa <- paste("Estatstica do Teste: ",
round(cortest.bartlett(correl.msa, n = n.msa)$chisq,2),
" (valor-p = ",
round(cortest.bartlett(correl.msa, n = n.msa)$p.value,4),
")",sep="")


############################################
#### TESTE KMO #####
############################################

kmo.test <- function(dados){

R <- cor(dados)
D <- diag(diag(sqrt(diag(diag(solve(R)))))^(-1))
Q <- D%*%solve(R)%*%D


sum((R - diag(diag(R)))^2) -> r
sum((Q - diag(diag(Q)))^2) -> q

kmo <- r/(r+q)
return(kmo)
}

kmo_mss <- kmo.test(dados.mss)
kmo_msa <- kmo.test(dados.msa)


########################
### Anlise Fatorial
#########################

## Nmero de fatores
m = qtd_dimensoes

#################
### Matriz MSS
#################

## Matriz de correlao
matriz_correl_1 <- cor(dados.mss,use="na.or.complete")

## Clculo da matriz de carregamentos L pelo mtodo das complonentes principais
carreg_mod_fatorial1 <- eigen(matriz_correl_1)[[2]]%*%diag(sqrt(eigen(matriz_correl_1)[[1]]))[,1:m]
carreg_rotat_mod_fatorial1 <- Varimax(carreg_mod_fatorial1,maxit=2000)

## Porcentagem da variabilidade total explicada
## pelo modelo fatorial
explic_fator_mss <- ((cumsum(eigen(matriz_correl_1)[[1]])/qtd_quest_servqual)*100) [m]


#################
### Matriz MSA
#################

## Matriz de correlao
matriz_correl_2 <- cor(dados.msa,use="na.or.complete")

## Clculo da matriz de carregamentos L pelo mtodo das complonentes principais
carreg_mod_fatorial2 <- eigen(matriz_correl_2)[[2]]%*%diag(sqrt(eigen(matriz_correl_2)[[1]]))[,1:m]
carreg_rotat_mod_fatorial2 <- Varimax(carreg_mod_fatorial2, maxit=2000)

## Porcentagem da variabilidade total explicada
## pelo modelo fatorial
explic_fator_msa <- ((cumsum(eigen(matriz_correl_2)[[1]])/qtd_quest_servqual)*100) [m]


## Scree-Plot

jpeg(paste("teste_scree_",numero_questao,"_",num_item,".jpeg",sep=""),w=600,h=600,quality=100)

plot(eigen(matriz_correl_1)[[1]],type="l",main="Teste Scree",las=1,lwd=2,ylab="",xlab="Autovalores",col="blue")
points(eigen(matriz_correl_1)[[1]],pch=2,col="blue")

lines(eigen(matriz_correl_2)[[1]],col="red",lwd=2)
points(eigen(matriz_correl_2)[[1]],pch=4,col="red")

abline(h=1,lty=2)
abline(v=m,lty=4,col="orange",lwd=2)

legend("topright", c("Matriz MSS", "Matriz MSA","Autovalor = 1",paste(m," autovalor",sep="")), col = c("blue","red","black","orange"),
            text.col = "black", lty = c(1, 1, 2, 4), pch = c(2, 4, NA, NA),
            merge = T,cex=.9)
dev.off()


#########################
##################
## Grava os carregamentos fatoriais da matrix MSS e MSA
##########
#####

################
###### Carregamentos rotacionados matriz MSS
###
col1.mss <- rep(seq(1:qtd_quest_servqual),m)
col2.mss <- rep(1:m,rep(qtd_quest_servqual,m))
col3.mss <- matrix(loadings(carreg_rotat_mod_fatorial1),ncol=1)

col4.mss <- rep(rowSums(carreg_mod_fatorial1^2),m)

carregamentos_mss <- cbind(col1.mss,col2.mss,col3.mss, col4.mss)
colnames(carregamentos_mss) <- c("questao","fator","carregamento","comunalidade")

dbWriteTable(con,"carregamentos_mss",data.frame(carregamentos_mss),overwrite = T)


################
###### Carregamentos rotacionados matriz MSA
###
col1.msa <- rep(seq(1:qtd_quest_servqual),m)
col2.msa <- rep(1:m,rep(qtd_quest_servqual,m))
col3.msa <- matrix(loadings(carreg_rotat_mod_fatorial2),ncol=1)

col4.msa <- rep(rowSums(carreg_mod_fatorial2^2),m)

carregamentos_msa <- cbind(col1.msa,col2.msa,col3.msa, col4.msa)

colnames(carregamentos_msa) <- c("questao","fator","carregamento","comunalidade")
dbWriteTable(con,"carregamentos_msa",data.frame(carregamentos_msa),overwrite = T)


############################
########################
### Alfa de Cronbach
#########################
###########################

#################
### Matriz MSS
#################

##################
## Alfa total da dimenso - matriz MSS (para cada uma das dimenses)
##################
alfas_mss <- NULL
for(i in 1:qtd_dimensoes){
alfas_mss[i] <- alpha(dados.mss[,dime_quest(i)])$total[[1]]
}

#################
### Matriz MSA
#################

##################
## Alfa total da dimenso - matriz MSA (para cada uma das dimenses)
##################
alfas_msa <- NULL
for(i in 1:qtd_dimensoes){
alfas_msa[i] <- alpha(dados.msa[,dime_quest(i)])$total[[1]]
}

alfas_dimensao <- data.frame(dimensoes,alfas_mss,alfas_msa,explic_fator_mss,explic_fator_msa, bartlett_mss, bartlett_msa, kmo_mss, kmo_msa)

## Grava os valores dos alfas de cronbach, por dimenso e 
## o total da varincia total dos dados originais explicada
## pelo modelo fatorial

dbWriteTable(con,"alfas_dimensao",alfas_dimensao,overwrite = T)

############################################33
###########################################3
##########################################333333333333

}

# Desconectamos
dbDisconnect(con)


tempo <- print(Sys.time()-start)

write.table(tempo,"tempo_execucao.txt",col.names=F,row.names=F)

#write.table(ifelse(dim(dados.mss)[1]>dim(dados.mss)[2],101010,33),"tamanho_bd.txt",col.names=F,row.names=F)